#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>

@interface methods : NSObject
+ (NSString *)makeTimeString:(long long)seconds;
+ (NSDictionary *)movieProperties:(NSMovieView *)movieView;
@end

@implementation methods

+ (NSString *)makeTimeString:(long long)seconds {
    long long minutes, hours;
    minutes = seconds/60;
    hours = minutes/60;
    seconds = seconds - (minutes * 60);
    minutes = minutes - (hours * 60);
	NSString *_seconds = [NSString stringWithFormat:@"%qi", seconds];
	NSString *_minutes = [NSString stringWithFormat:@"%qi", minutes];
	if ([_seconds length] < 2) _seconds = [NSString stringWithFormat:@"0%@", _seconds];
	if ([_minutes length] < 2) _minutes = [NSString stringWithFormat:@"0%@", _minutes];
    return [NSString stringWithFormat:@"%qi:%@:%@", hours, _minutes, _seconds];
}

+ (NSDictionary *)movieProperties:(NSMovieView *)movieView {
    NSMutableDictionary *returnData = [NSMutableDictionary dictionary];
    Movie qtmovie = [[movieView movie] QTMovie];
    Rect boundsRect;
	
    GetMovieNaturalBoundsRect(qtmovie, &boundsRect);
    [returnData setObject:[NSNumber numberWithFloat:(boundsRect.right - boundsRect.left)] forKey:@"default_width"];
    [returnData setObject:[NSNumber numberWithFloat:(boundsRect.bottom - boundsRect.top)] forKey:@"default_height"];
    
    GetMovieBox(qtmovie, &boundsRect);
    [returnData setObject:[NSNumber numberWithFloat:(boundsRect.right - boundsRect.left)] forKey:@"current_width"];
    [returnData setObject:[NSNumber numberWithFloat:(boundsRect.bottom - boundsRect.top)] forKey:@"current_height"];
    
    [returnData setObject:[NSDate dateWithTimeIntervalSinceReferenceDate:(double)((GetMovieCreationTime(qtmovie)) - 0xB6757900)] forKey:@"creation_date"];
    [returnData setObject:[NSDate dateWithTimeIntervalSinceReferenceDate:(double)((GetMovieModificationTime(qtmovie)) - 0xB6757900)] forKey:@"modification_date"];
	
    TimeScale timeScale = GetMovieTimeScale(qtmovie);
    [returnData setObject:[self makeTimeString:((GetMovieDuration(qtmovie)) / timeScale)] forKey:@"duration_string"];
    [returnData setObject:[self makeTimeString:((GetMovieTime(qtmovie, nil)) / timeScale)] forKey:@"current_time_string"];
    
    return returnData;
}

@end
