property movie_view : missing value
property movie_loaded : false
property titlebar_and_controller_offset : 38

on awake from nib the_object
	tell the_object
		set movie_view to view "movie"
		center
		show
	end tell
end awake from nib

on clicked the_object
	set object_name to (name of the_object) as Unicode text
	if object_name = "load_movie" then
		my load_movie()
		
	else if object_name = "log_properties" then
		log (call method "movieProperties:" of class "methods" with parameters {movie_view})
		
	end if
end clicked

on should quit after last window closed the_object
	return true
end should quit after last window closed

on choose menu item the_object
	set object_name to (name of the_object) as Unicode text
	if object_name = "load_movie" then
		my load_movie()
		
	end if
end choose menu item

on display_error(the_title, the_error)
	activate
	beep
	display alert the_title as critical message the_error default button "OK" attached to window "main"
end display_error

on load_movie()
	set the_movie_path to (choose file with prompt "Choose a movie:" without invisibles)
	set display_name to (info for the_movie_path)'s displayed name
	tell movie_view
		try
			try
				delete movie of it
			end try
			set the_movie to (load movie (the_movie_path as alias))
			set movie of it to the_movie
			set movie_loaded to true
		on error
			set movie_loaded to false
		end try
	end tell
	set enabled of button "log_properties" of window "controller" to movie_loaded
	if movie_loaded then
		set the_properties to (call method "movieProperties:" of class "methods" with parameters {movie_view})
		tell window "main"
			set title to display_name
			set {x1, y1, x2, y2} to bounds
			set new_height to (the_properties's default_height) + titlebar_and_controller_offset
			set y1 to y2 - new_height
			set y2 to y1 + new_height
			set minimum size to {90, titlebar_and_controller_offset}
			if (the_properties's default_width > 0) then
				set x2 to x1 + (the_properties's default_width)
				set maximum size to {10000, 10000}
			else
				set maximum size to {10000, titlebar_and_controller_offset}
			end if
			set bounds to {x1, y1, x2, y2}
			call method "makeKeyAndOrderFront:" of it
		end tell
	else
		my display_error("Load Error", "Could not load the file " & the_movie_path & " as a movie. Please try another file.")
	end if
end load_movie